// Copyright(c) 1997 ObjectSpace, Inc.

import COM.objectspace.jgl.*;
import java.text.Collator;

/**
 * Comparison using Collator objects.
 *
 * @see COM.objectspace.jgl.LessCollator
 * @see COM.objectspace.jgl.LessEqualCollator
 * @see COM.objectspace.jgl.GreaterCollator
 * @see COM.objectspace.jgl.GreaterEqualCollator
 * @see java.text.Collator
 * @version 2.0.2
 * @author ObjectSpace, Inc.
 */

public class Collate3
  {
  public static void show( String tag, BinaryPredicate predicate )
    {
    // create a set with given comparitor that allows duplicates
    OrderedSet set = new OrderedSet( predicate, true );

    // add a few entries
    set.add( "Texas" );
    set.add( "texas" );
    set.add( "Texas Fight" );

    // print the resulting container
    System.out.println( tag + "\n\t" + set );
    }

  public static void main( String args[] )
    {
    show( "old style", new LessString() );
    show( "default collating", new LessCollator() );

    Collator collator = Collator.getInstance();
    collator.setStrength( Collator.PRIMARY );
    show( "case insensitive", new LessCollator( collator ) );
    }
  }
