// Copyright(c) 1997 ObjectSpace, Inc.

package COM.objectspace.jgl;

/**
 * NotEqualString is a binary predicate that returns true
 * if the first operand as a string is not equal to the second operand
 * as a string.
 * <p>
 * @version 2.0.2
 * @author ObjectSpace, Inc.
 */

public final class NotEqualString implements BinaryPredicate
  {
  /**
   * Return true if the first operand is not equal to the second operand.
   * @return first.toString() != second.toString()
   */
  public boolean execute( Object first, Object second )
    {
    return !first.toString().equals( second.toString() );
    }
  }
